<template>
  <v-container>
    <v-row>
      <v-col lg="9" md="12" sm="12">
        <v-autocomplete
          v-model="select"
          :loading="loading"
          :items="datas"
          :search-input.sync="search"
          item-text="title"
          item-value="title"
          cache-items
          flat
          hide-no-data
          hide-details
          label="What movie are you looking for?"
          solo-inverted
          clearable
          class="mb-5"
        ></v-autocomplete>
      </v-col>
      <v-col lg="3" md="12" sm="12">
        <v-menu
          v-model="menu"
          :close-on-content-click="false"
          :nudge-right="40"
          transition="scale-transition"
          offset-y
          min-width="auto"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="date"
              label="Select Date"
              prepend-icon="mdi-calendar"
              readonly
              solo-inverted
              clearable
              v-bind="attrs"
              v-on="on"
            ></v-text-field>
          </template>
          <v-date-picker v-model="date" @input="menu = false"></v-date-picker>
        </v-menu>
      </v-col>
    </v-row>
    <div v-if="loading">
      <v-row>
        <v-col v-for="(item, i) in 8" :key="i" lg="3">
          <v-skeleton-loader
            class="mx-auto"
            max-width="300"
            type="card"
          ></v-skeleton-loader>
        </v-col>
      </v-row>
    </div>
    <v-row v-else>
      <v-col v-for="(item, i) in paginatedData" :key="i" lg="3">
        <v-card class="mx-auto" max-width="400">
          <v-img
            gradient="to top right, rgba(100,115,201,.33), rgba(25,32,72,.7)"
            class="white--text align-end"
            height="200px"
            :src="item.image"
          >
            <v-card-title>{{ item.title }}</v-card-title>
          </v-img>

          <v-card-subtitle class="pb-0">
            Show Time
          </v-card-subtitle>

          <v-card-text class="text--primary">
            <div>
              {{ $moment(item.showTime).format("DD MMMM YYYY") }}
              {{ $moment(item.showTime).format("h:mm a") }}
            </div>
          </v-card-text>

          <v-card-actions>
            <v-btn color="red" text @click="$router.push(`/${item.id}`)">
              See Detail
            </v-btn>

            <div class="ml-auto">
              <v-icon class="mr-1">
                mdi-heart
              </v-icon>
              <span class="subheading mr-2">{{ item.like }}</span>
            </div>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <div class="text-center mt-7 mb-3">
      <v-pagination
        v-model="page_number"
        :length="pageCount === 0 ? 1 : pageCount"
        :total-visible="6"
        @input="nextPage"
        color="red"
      ></v-pagination>
    </div>
  </v-container>
</template>

<script>
export default {
  data() {
    return {
      date: "",
      menu: false,
      data_filtered: [],
      page_number: 1,
      size: 12,
      search: null,
      select: null,
      loading_select: false
    };
  },
  computed: {
    datas() {
      return this.$store.get("datas");
    },
    loading() {
      return this.$store.get("loading");
    },
    pageCount() {
      let l = this.data_filtered.length,
        s = this.size;
      return Math.ceil(l / s) - 1;
    },
    paginatedData() {
      const start = this.page_number * this.size - this.size,
        end = start + this.size;
      return this.data_filtered.slice(start, end);
    }
  },
  watch: {
    datas(val) {
      this.data_filtered = val;
    },
    select(val) {
      this.page_number = 1;
      if (val) {
        if (this.date) {
          this.data_filtered = this.datas.filter(item => {
            return (
              item.title === val &&
              this.$moment(item.showTime).format("YYYY-MM-DD") === this.date
            );
          });
        } else {
          this.data_filtered = this.datas.filter(item => {
            return item.title === val;
          });
        }
      } else {
        if (this.date) {
          this.data_filtered = this.datas.filter(item => {
            return (
              this.$moment(item.showTime).format("YYYY-MM-DD") === this.date
            );
          });
        } else {
          this.data_filtered = this.datas;
        }
      }
    },
    date(val) {
      this.page_number = 1;
      if (val) {
        if (this.select) {
          this.data_filtered = this.datas.filter(item => {
            return (
              this.$moment(item.showTime).format("YYYY-MM-DD") === val &&
              item.title === this.select
            );
          });
        } else {
          this.data_filtered = this.datas.filter(item => {
            return this.$moment(item.showTime).format("YYYY-MM-DD") === val;
          });
        }
      } else {
        if (this.select) {
          this.data_filtered = this.datas.filter(item => {
            return item.title === this.select;
          });
        } else {
          this.data_filtered = this.datas;
        }
      }
    }
  },
  mounted() {
    this.load();
  },
  methods: {
    load() {
      this.$store.dispatch("loadData");
    },
    nextPage(page) {
      this.page_number = page;
    }
  }
};
</script>
